hirom
;header

!freespace_C2_0 = $C2A65A
!freespace_C2_1 = $C2FAB0

org $C2256D				
JSR condenseSpellLists ; this was originally a JSR to modify available commands; we'll be JMPing to that 
							; at the end of the modified code so that RTS comes back to the right spot


							
org $C24F11
REP #$10
LDA $3A7B				; (get attack #) -- the new code will do this again in a bit, but
CPX #$0008				; we need it in A now or we'll break monster casting
BCS fka_4F47			; (branch if it's a monster attacker.  they don't have
						; menus containing MP data, nor relics that can
						; alter MP costs.)
						; This was originally in the middle of the code, but 
						; there shouldn't be any issues doing this check first,
						; and it makes the new code MUCH smoother.
JMP calculateMPDeduction

org $C24F47
fka_4F47:

							
org !freespace_C2_0
condenseSpellLists:
PHX				; This is our character ID coming in
PHP
REP #$10
LDY #$0004		; this is the index of the first Spell slot in the character's spell list
STY $F0		; 
LDX #$004A		; this is our main loop index; we're checking 53 spells and 23 lores, since we 
				; don't need to check the last slot of either list 
	.checkLoreLoop		; don't need to actually check the last slot of either list
	LDA ($F2),Y
	CMP #$FF
	BNE .checkNextLore

		.findNextLore
		INY #4
		CPY #$00DC	; if we've hit the first Lore slot, there are no more spells to copy back
		BEQ .noMoreSpells	; so jump out, reset $F0 to start our lores
		CPY #$013C	; this is after the last Lore slot, so if we've gone that far, there are no more spells to copy back
		BEQ .noMoreLores
		LDA ($F2),Y
		CMP #$FF
		BEQ .findNextLore

	PHX			; set aside the starting byte for the spell we found
	PHY			; we'll be pushing and pulling within the loop, but we need to know 
	LDX #$0003	; where it started so we can blank out the slot we copied from
	
		.copyNextLore
		LDA ($F2),Y	; Yes, we just did this, but we need to do it within this loop, too
		PHY			; this stores our Y location, i.e. the next slot with a spell learned
		LDY $F0		; and loads our index for slot to write to
		STA ($F2),Y
		PLY			; back to our 'write from' location
		INY			; and gets the next byte
		REP #$20
		INC $F0		; while getting our next write-to byte, too. on the last loop,
					; this will get set to the first byte of the next spell slot (which 
		SEP #$20
		DEX			
		BPL .copyNextLore	; if we haven't done four bytes, loop back and grab the next

	PLY			; this is the first byte of the slot we copied from
	LDA #$FF
	STA ($F2),Y	; this blanks out the spell we copied from
	LDA #$00
	STA ($F4),Y	; and zeroes out the MP cost
		
	PLX				; this gets our index for the loop -- how many spell slots we've checked
	BRA .weCopiedALore
	.checkNextLore
	REP #$20
	INC $F0			; if we DIDN'T copy a spell, we need to increment our 'current slot' index
	INC $F0			; but if we did, the loop already has it pointing to the next slot
	INC $F0
	INC $F0
	SEP #$20
	.weCopiedALore
	LDY $F0			; and then copy it over to Y for our next loop through
	CPY #$00D8		; if this is the last spell slot
	BEQ .checkNextLore	;loop back up and INC again so we skip over it and point at our first Lore slot
	
	DEX
	BPL .checkLoreLoop
	.noMoreLores
	
PLP	
PLX
JMP $532C

.noMoreSpells
LDX #$0016			; reset our index to cover just the Lores
STY $F0				; and reset our working index for the first Lore slot
BRA .checkLoreLoop



org !freespace_C2_1
calculateMPDeduction:

REP #$10			; (Set 16-bit X and Y)
LDA $3A7A			; (get command #)
CMP #$19
BEQ .calculateSummon	; (branch if it's Summon)
CMP #$0C
BEQ .calculateLore	; (branch if it's Lore)
CMP #$02
BEQ .calculateMagic	; (branch if it's Magic)
CMP #$17
BNE fka_4F53		; (branch if it's not X-Magic)

.calculateMagic
LDA $3A7B			; (get attack #)
STA $F0						; save our spell ID in scratch memory
REP #$20
LDA #$0004					; four bytes per index

.loreEntersHere
CLC
ADC $302C,X 				; get the start of our character's magic list (index #0 is esper)
STA $F2						; this points out our first Magic slot
INC #3
STA $F4						; and this points at our first MP cost slot
SEP #$20
PHY
LDY #$0000

	.findSpell
	LDA ($F2),Y
	CMP $F0
	BEQ .getMPCost
	CMP #$FF
	BEQ fka_4F53
	INY #4
	BRA .findSpell
	
.getMPCost
LDA ($F4),Y
PLY
BRA fka_4F45

.calculateLore
LDA $3A7B					; (get attack #)
SEC
SBC #$8B					; turn our raw spell ID into a 0-23 Lore ID
STA $F0
REP #$20
LDA #$00DC					; this is our first Lore slot in the character's spell list
BRA .loreEntersHere

.calculateSummon			; rather than looking for the spell ID, I'm operating under
REP #$20					; the assumption that if someone is using Summon, it's already
LDA $302C,X					; checked for the equipped Esper, so I'm just loading the MP cost
TAX							; from the first entry in the character's list
SEP #$20
LDA $0003,X
BRA fka_4F45


fka_4F45: JMP $4F54			; (clean up stack and exit)
fka_4F53: JMP $4F53